﻿$(document).ready(function () {
    $("#dialogNewField").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    $('#aNewField').click(function () {
        $("#dialogNewField").dialog('open');
    });

    $("#dialogImportItems").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: "Importovat",
                click: function () {
                    if (filesUploaded) {
                        OnAjaxBegin('Importuji data...');
                        var arr = new Array;
                        $("#dialogFieldProperties #listboxItems option").each(function () {
                            arr.push({ Id: parseInt($(this).val()), Title: $(this).data('title'), Disabled: $(this).attr('data-disabled'), DefaultValueBoolean: $(this).data('checked'), Index: i++, CustomFormFieldItemIndex: $(this).attr('data-depends') });
                        });
                        $.ajax({
                            url: RQ_URL + "/CustomForms/ImportData",
                            type: "POST",
                            data: JSON.stringify({
                                importColumnIndex: $("#DialogSelectedColumn").val(),
                                index: $("#dialogFieldProperties #hiddenIndex").val(),
                                haveHeader: $("#DialogImportItemsHaveHeader").is(':checked'),
                                checkDuplicity: $("#DialogImportItemsCheckDuplicity").is(':checked'),
                                customFormFieldItems: arr,
                            }),
                            dataType: "json",
                            contentType: "application/json; charset=utf-8",
                            success: function (g) {
                                $("#dialogImportItems").dialog("close");
                                uploader.destroy();
                                $("#dialogFieldProperties #listboxItems").empty();

                                $.each(g, function (index, value) {
                                    $("#dialogFieldProperties #listboxItems").append("<option value='" + value.Id + "' data-title='" + value.Title + "' data-disabled='" + value.Disabled + "' data-checked='" + value.DefaultValueBoolean + "' " + (value.Disabled ? "class='disabled-item'" : "") + " data-depends='" + (value.CustomFormFieldItemIndex != null ? value.CustomFormFieldItemIndex : "") + "'>" + value.Title + "</option>");
                                });
                            },
                            error: function (error) { alert(error.responseText); },
                            complete: function () {
                                OnAjaxComplete();
                            }
                        });
                    }
                    else {
                        $("#ValidFile").show();
                    }
                    //$(this).dialog("close");
                }
            },
            {
                text: "Zrušit",
                click: function () {
                    uploader.destroy();
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-preview").dialog({
        autoOpen: false,
        resizable: true,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialogFieldProperties").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    $("#dialogFieldProperties #tbTitle").next('.valid-error').hide();
                    $("#dialogFieldProperties #tbRegularExpression").next('.valid-error').hide();

                    if ($("#dialogFieldProperties #tbTitle").val() == "") {
                        $("#dialogFieldProperties #tbTitle").next('.valid-error').show();
                    }
                    else if ($("#dialogFieldProperties #hiddenType").val() == 'RegularExpression' && $("#dialogFieldProperties #tbRegularExpression").val() == "") {
                        $("#dialogFieldProperties #tbRegularExpression").next('.valid-error').show();
                    }
                    else {
                        var arr = new Array;
                        var i = 0;
                        $("#dialogFieldProperties #listboxItems option").each(function () {
                            var result = null;
                            if ($(this).attr('data-defaultvalue') != undefined && $(this).attr('data-defaultvalue') != "") {
                                result = $(this).attr('data-defaultvalue').split(',').map(function (x) {
                                    return parseInt(x);
                                });
                            }
                            arr.push({ Id: parseInt($(this).val()), Title: $(this).data('title'), Disabled: $(this).attr('data-disabled'), DefaultValueBoolean: $(this).data('checked'), Index: i++, CustomFormFieldItemIndex: $(this).attr('data-depends'), DefaultValues: result });
                        });

                        $.ajax({
                            url: RQ_URL + "/CustomForms/" + $("#hiddenFieldAction").val(),
                            type: "POST",
                            data: JSON.stringify({
                                session_id: $('#hiddenSessionId').val(),
                                Type: $("#dialogFieldProperties #hiddenType").val(),
                                Index: $("#dialogFieldProperties #hiddenIndex").val(),
                                Title: $("#dialogFieldProperties #tbTitle").val(),
                                Description: $("#dialogFieldProperties #tbDescription").val(),
                                Required: $("#dialogFieldProperties #cbRequired").is(':checked'),
                                RequiredWhenFinished: $("#dialogFieldProperties #cbRequiredWhenFinished").is(':checked'),
                                AllowEditingByOperatorsOnly: $("#dialogFieldProperties #cbAllowEditingByOperatorsOnly").is(':checked'),
                                PlaceHolderText: $("#dialogFieldProperties #tbPlaceHolderText").val(),
                                RegularExpression: $("#dialogFieldProperties #tbRegularExpression").val(),
                                AddPleaseSelect: $("#dialogFieldProperties #cbAddPleaseSelect").is(':checked'),
                                CustomFormFieldIndex: $("#dialogFieldProperties #CustomFormFieldIndex").val(),
                                CustomFormFieldItems: arr,
                                DefaultValueParent: $("#listboxItems").attr("data-defaultvalueindexparent"),
                                ReadOnly: $("#ReadOnly").val(),
                                NewPage: $("#NewPage").is(':checked'),
                            }),
                            dataType: "json",
                            contentType: "application/json; charset=utf-8",
                            success: function () {
                                ReloadTableOfFields();
                            },
                            error: function (error) { alert(error.responseText); },
                        });

                        $("#dialog-set-default-items").dialog('destroy');
                        $(this).dialog("close");
                    }
                }
            },
            {
                text: Localization_Cancel,
                click: function () {
                    $("#dialog-set-default-items").dialog('destroy');
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialogNewField a").click(function () {
        $("#dialogNewField").dialog('close');
        $("#dialogFieldProperties").html('<div class="loading-32"></div>');
        $("#dialogFieldProperties").dialog('open');

        var fieldType = $(this).data('field-type');
        $("#hiddenFieldAction").val('AddField');
        $("#hiddenFieldType").val(fieldType);
        $("#dialogFieldProperties").load(RQ_URL + "/CustomForms/PartialNewFieldProperties", { fieldType: fieldType, session_id: $('#hiddenSessionId').val() }, function () {
            $("#dialogFieldProperties").dialog('close');
            $("#dialogFieldProperties").dialog('open'); //recenter
        });
    });

    $("#tableOfFields").on('click', 'a.delete-field', function () { //dynamically created elements - needs .on instead of .click event
        $(this).addClass("loading-16");
        var $a = $(this);

        $.post(
            RQ_URL + "/CustomForms/DeleteField",
            {
                index: $(this).data("field-index"),
                session_id: $('#hiddenSessionId').val(),
            },
            "json"
            )
            .fail(function (error) { alert(error.responseText); })
            .done(function () { ReloadTableOfFields(); })
            .always(function () {
                $a.removeClass("loading-16");
            });
    });

    $("#dialogFieldProperties").on("change", "#CustomFormFieldIndex", function () {
        var dp = $("#dialogFieldProperties #listboxItems option");
        var doesNotHaveDepends = true;
        for (var i = 0; i < dp.length; i++) {
            if ($(dp[i]).attr("data-depends") != "" && $(dp[i]).attr("data-depends") != undefined) {
                doesNotHaveDepends = false;
            }
        }

        var confirmResult = false;
        if (!doesNotHaveDepends) {
            confirmResult = confirm("Při změně položky dojde k ztrátě závislostí u všech prvků");
        }

        if (doesNotHaveDepends || confirmResult) {
            $(this).attr("data-lastvalue", $(this).val());
            $("#dialogFieldProperties #listboxItems option").each(function () {
                $(this).attr("data-depends", "");
            });
            if ($("#CustomFormFieldIndex").val() != "") {
                $("#cbAddPleaseSelect").prop("disabled", true);
                $("#cbAddPleaseSelect").prop("checked", true);
                $.ajax({
                    url: RQ_URL + "/CustomForms/GetCustomFormFieldItems?index=" + $("#CustomFormFieldIndex").val(),
                    type: "GET",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        $("#CustomFormFieldItems").empty();
                        $("#CustomFormFieldItems").append("<select id='CustomFormFieldItemsSelect'></select>");

                        if ($("#listboxItems :selected").length > 0 && $("#CustomFormFieldIndex").val() != "") {
                            $("#CustomFormFieldSelectedItems").closest("div").show();
                            $("#CustomFormFieldItemsSelect").closest("div").show();
                        }

                        $("#CustomFormFieldItemsSelect").append("<option value='' >Vyberte prosím...</option>");
                        $.each(g, function (index, value) {
                            $("#CustomFormFieldItemsSelect").append("<option value='" + value.Value + "' >" + value.Text + "</option>");
                            if (index == 0) {
                                setDepends($("#CustomFormFieldItemsSelect"));
                            }
                        });
                    },
                });
            }
            else {
                $("#cbAddPleaseSelect").prop("disabled", false);
                $("#cbAddPleaseSelect").prop("checked", false);
                $("#CustomFormFieldItemsSelect").closest("div").hide();
                $("#CustomFormFieldSelectedItems").closest("div").hide();
                $("#CustomFormFieldItems").empty();
            }
        }
        else {
            $(this).val($(this).attr("data-lastvalue"));
        }
    });

    $("#dialogFieldProperties").on("change", "#CustomFormFieldItemsSelect", function () {
        setDepends(this);
    });

    $("#tableOfFields").on('click', 'a.edit-field', function () { //dynamically created elements - needs .on instead of .click event

        $("#dialogFieldProperties").html('<div class="loading-32"></div>');
        $("#dialogFieldProperties").dialog('open');

        $("#hiddenFieldAction").val('EditField');
        $("#dialogFieldProperties").load(RQ_URL + "/CustomForms/PartialEditFieldProperties", { index: $(this).data("field-index"), session_id: $('#hiddenSessionId').val() }, function () {
            $("#dialogFieldProperties").dialog('close');
            $("#dialogFieldProperties").dialog('open'); //recenter
        });
    });

    $("#tableOfFields").on('click', 'a.move-up, a.move-down', function () { //dynamically created elements - needs .on instead of .click event
        $('#tableOfFields th#move').addClass("loading-16");

        $.post(
            RQ_URL + "/CustomForms/MoveField",
            {
                index: $(this).data("field-index"),
                moveDown: $(this).hasClass('move-down'),
                session_id: $('#hiddenSessionId').val(),
            },
            "json"
            )
            .fail(function (error) { alert(error.responseText); })
            .done(function () { ReloadTableOfFields(); })
            .always(function () { $('#tableOfFields th#move').removeClass("loading-16"); });
    });

    $("#tableOfFields").on('click', 'a.enable-field, a.disable-field', function () { //dynamically created elements - needs .on instead of .click event
        $(this).addClass("loading-16");

        $.post(
            RQ_URL + "/CustomForms/EnableDisableField",
            {
                index: $(this).data("field-index"),
                disable: $(this).hasClass('disable-field'),
                session_id: $('#hiddenSessionId').val(),
            },
            "json"
            )
            .fail(function (error) { alert(error.responseText); })
            .done(function () { ReloadTableOfFields(); })
            .always(function () { $(this).removeClass("loading-16"); });
    });

    $("#dialogFieldProperties").on('click', '#cbRequired', function () {
        $("#dialogFieldProperties #cbRequiredWhenFinished").prop('disabled', $(this).is(':checked'));
        $("#dialogFieldProperties label[for='cbRequiredWhenFinished']").toggleClass("disabled");
    });

    $("#dialogFieldProperties").on('click', '#aItemAdd', function () {
        var title = $("#tbItemText").val().trim();
        var checked = $("#cbItemChecked").is(":checked");

        if (title != '') {
            var text = title;

            if (checked) {
                text += " [X]";
            }

            $("#listboxItems").append($("<option/>", { value: 0, text: text, "data-title": title, "data-checked": checked, "data-disabled": "False" }));
            $("#tbItemText").val('');
            $("#cbItemChecked").prop("checked", false);
        }
    });

    $("#dialogFieldProperties").on('click', '#aItemDelete', function () {
        $("#listboxItems option:selected").remove();
        $("#aItemUpdate").attr("disabled", "disabled");
        $("#aItemMoveUp").attr("disabled", "disabled");
        $("#aItemMoveDown").attr("disabled", "disabled");
        $("#aItemDelete").attr("disabled", "disabled");
        $("#aItemDisabled").attr("disabled", "disabled");
        $("#aItemEnable").attr("disabled", "disabled");
    });

    $("#dialogFieldProperties").on('click', '#aItemMoveUp', function () {
        $("#listboxItems option:selected").each(function () {
            var listItem = $(this);
            var listItemIndex = $("#listboxItems option").index(listItem);
            if (listItemIndex > 0) {
                listItem.insertBefore(listItem.prev());
            }
        });
    });

    $("#dialogFieldProperties").on('click', '#aItemMoveDown', function () {
        var itemsCount = $("#listboxItems option").length;
        $($("#listboxItems option:selected").get().reverse()).each(function () {
            var listItem = $(this);
            var listItemIndex = $("#listboxItems option").index(listItem);
            if (listItemIndex < itemsCount) {
                listItem.insertAfter(listItem.next());
            }
        });
    });

    $("#dialogFieldProperties").on('click', '#aItemUpdate', function () {
        var title = $("#tbItemText").val().trim();
        var checked = $("#cbItemChecked").is(":checked");

        if (title != '') {
            var text = title;

            if (checked) {
                text += " [X]";
            }

            var item = $("#listboxItems :selected");
            item.text(text);
            item.data('title', title);
            item.data('checked', checked);

            $("#tbItemText").val(title); //if trimmed
        }
    });

    $("#dialogFieldProperties").on('click', '#aItemDisabled', function () {
        var item = $("#listboxItems :selected");
        item.attr('data-disabled', "True");
        item.addClass("disabled-item");
        $("#aItemDisabled").hide();
        $("#aItemEnable").show();
    });


    $("#dialogFieldProperties").on('click', '#aItemEnable', function () {
        var item = $("#listboxItems :selected");
        item.attr('data-disabled', "False");
        item.removeClass("disabled-item");
        $("#aItemDisabled").show();
        $("#aItemEnable").hide();
    });

    $("#dialogFieldProperties").on('change', '#listboxItems', function () {
        var item = $("#listboxItems :selected");
        var title = item.data('title');
        var checked = item.data('checked');
        var depends = item.attr('data-depends');
        var disabled = item.attr('data-disabled');
        if (disabled.toLowerCase() == "true") {
            $("#aItemDisabled").hide();
            $("#aItemEnable").show();
        }
        else {
            $("#aItemDisabled").show();
            $("#aItemEnable").hide();
        }

        $("#tbItemText").val(title);
        $("#cbItemChecked").prop("checked", checked);
        if ($("#listboxItems :selected").length > 0 && $("#CustomFormFieldIndex").val() != "") {
            $("#CustomFormFieldSelectedItems").closest("div").show();
            $("#CustomFormFieldItemsSelect").closest("div").show();
        }

        $("#CustomFormFieldSelectedItems").text("");
        $.each(item, function (index, value) {
            if (index == 0) {
                $("#CustomFormFieldSelectedItems").text($(value).text());
            }
            else {
                $("#CustomFormFieldSelectedItems").text($("#CustomFormFieldSelectedItems").text() + ", " + $(value).text());
            }
        });

        if (item.length == 1) {
            $("#CustomFormFieldItemsSelect").val(depends);

            $("#aItemUpdate").removeAttr("disabled", "disabled");
            $("#aItemMoveUp").removeAttr("disabled", "disabled");
            $("#aItemMoveDown").removeAttr("disabled", "disabled");
            $("#aItemDelete").removeAttr("disabled", "disabled");
            $("#aItemDisabled").removeAttr("disabled", "disabled");
            $("#aItemEnable").removeAttr("disabled", "disabled");
        }
        else {
            $("#CustomFormFieldItemsSelect").val("");
            $("#aItemUpdate").attr("disabled", "disabled");
            $("#aItemMoveUp").attr("disabled", "disabled");
            $("#aItemMoveDown").attr("disabled", "disabled");
            $("#aItemDelete").attr("disabled", "disabled");
            $("#aItemDisabled").attr("disabled", "disabled");
            $("#aItemEnable").attr("disabled", "disabled");
        }
    });

    $("#dialogFieldProperties").on('input', '#tbItemText', function () {
        if ($(this).val() == '') {
            $("#aItemAdd").attr("disabled", "disabled");
        }
        else {
            $("#aItemAdd").removeAttr("disabled");
        }
    });

    $("#aServiceAdd").click(function () {
        var serviceId = $('#ddlServices').val();

        if (serviceId != -1) {
            var exists = $("div#custom-form-services > div[data-serviceid='" + serviceId + "']").length > 0;

            if (!exists) {
                var hiddenServiceNextIndex = $("#hiddenServiceNextIndex");
                var i = parseInt(hiddenServiceNextIndex.val());

                var html =
                    '<div data-serviceid="' + serviceId + '">' +
                        '<strong>' + htmlEncode($('#ddlServices :selected').text().trim()) + '</strong> ' +
                        '<input type="hidden" name="SelectedServices[' + i + '].ServiceId" value="' + serviceId + '" />' +
                        '<input type="hidden" name="SelectedServices.Index" value="' + i + '" />' +
                        '<label><input type="checkbox" name="SelectedServices[' + i + '].INC" checked value="true" />INC</label> ' +
                        '<label><input type="checkbox" name="SelectedServices[' + i + '].REQ" checked value="true" />REQ</label> ' +
                        '<label><input type="checkbox" name="SelectedServices[' + i + '].PRO" checked value="true" />PRO</label> ' +
                        '<label><input type="checkbox" name="SelectedServices[' + i + '].CHG" checked value="true" />CHG</label> ' +
                        '<a class="delete" href="javascript:void(0);" data-service-id="' + serviceId + '"><img src="' + RQ_URL + '/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" /></a>' +
                    '</div>';

                $('#lbNoServiceSelected').hide();
                hiddenServiceNextIndex.before(html);
                hiddenServiceNextIndex.val(i + 1);
            }
        }
    });

    $("#custom-form-services").on('click', 'a.delete', function () {
        $(this).parent().remove();

        if ($('div#custom-form-services > div').length == 0) {
            $('#lbNoServiceSelected').show();
        }
    });

    $("#dialogLayoutTemplate").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    $('#hiddenLayoutTemplate').val(window.tinyMCE.get('tbLayoutTemplate').getContent());
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });


    $("#cbCustomLayout").change(function () {
        if ($(this).is(":checked")) {
            $("#aEditLayoutTemplate").removeAttr("disabled");
        }
        else {
            $("#aEditLayoutTemplate").attr("disabled", "disabled");
        }
    })

    $("#aEditLayoutTemplate").click(function () {

        if ($(this).attr("disabled"))
            return;

        if ($('#hiddenLayoutTemplate').val()) { //is not empty
            window.tinyMCE.get('tbLayoutTemplate').setContent($('#hiddenLayoutTemplate').val());
            $("#dialogLayoutTemplate").dialog('open');
        }
        else {
            OnAjaxBegin();

            $.post(
                RQ_URL + '/CustomForms/GenerateDefaultLayoutTemplate',
                {
                    session_id: $('#hiddenSessionId').val(),
                },
                function (data) {
                    $('#hiddenLayoutTemplate').val(data);
                },
                "json"
            )
                .fail(function (error) { alert(error.responseText); })
                .done(function () {
                    window.tinyMCE.get('tbLayoutTemplate').setContent($('#hiddenLayoutTemplate').val());
                    $("#dialogLayoutTemplate").dialog('open');
                })
                .always(function () { OnAjaxComplete(); });
        }


        $(".customform-legend").html('<div class="loading-32"></div>');

        $.post(
            RQ_URL + '/CustomForms/GenerateLayoutTemplateLegends',
            {
                session_id: $('#hiddenSessionId').val(),
            },
            function (data) {
                $(".customform-legend").html(data);
            },
            "json"
        )
            .fail(function (error) { alert(error.responseText); });
    });


    //INIT
    InitTinyMCE();

    $("#DialogMySeparator").change(function () {
        SetSeparatorName(this);
        changeSeparator();
    })

    $("#DialogMySeparator").keyup(function () {
        SetSeparatorName(this);
    })

    $("#dialogFieldProperties").on("click", "#DialogSetDefaultItems", function () {
        openDialog();
    });

    $("body").on("change", "#DialogDropDownItems", function () {
        var defaultValues = ($("#DialogDropDownItems :selected").attr("data-defaultvalue") + "").split(',');
        $("#CustomFormMapItemsSelect").val(defaultValues).trigger("change");
    });

    $("body").on("change", "#CustomFormMapDropDownsSelect", function () {
        var defaultValues = $("#DialogDropDownItems option");
        var doesNotHaveDefaultvalues = true;
        for (var i = 0; i < defaultValues.length; i++) {
            if ($(defaultValues[i]).attr("data-defaultvalue") != "" && $(defaultValues[i]).attr("data-defaultvalue") != undefined) {
                doesNotHaveDefaultvalues = false;
            }
        }

        var confirmResult = false;
        if (!doesNotHaveDefaultvalues && !openDialogDoNotRemoveDefaultValue) {
            confirmResult = confirm("Při změně položky dojde k ztrátě vychozích hodnot u všech prvků");
        }

        if (doesNotHaveDefaultvalues || confirmResult || openDialogDoNotRemoveDefaultValue) {
            $(this).attr("data-lastvalue", $(this).val());
            if (!openDialogDoNotRemoveDefaultValue) {
                $("#CustomFormMapItemsSelect").val(null).trigger("change");
                $("#DialogDropDownItems option").each(function () {
                    $(this).attr("data-defaultvalue", "");
                });
            }
            openDialogDoNotRemoveDefaultValue = false;
            $.ajax({
                url: RQ_URL + "/CustomForms/GetCustomFormFieldItems?index=" + $(this).val() + "&session_id=" + $('#hiddenSessionId').val(),
                type: "GET",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (g) {
                    $("#CustomFormMapItemsDiv").empty();
                    $("#CustomFormMapItemsDiv").append("<select id='CustomFormMapItemsSelect' multiple='multiple'></select>");
                    $("#CustomFormMapItemsSelect").select2({ width: '100%' }).change(function () {
                        $("#DialogDropDownItems :selected").attr("data-defaultvalue", $("#CustomFormMapItemsSelect").val());
                    });

                    $.each(g, function (index, value) {
                        $("#CustomFormMapItemsSelect").append("<option value='" + value.Value + "' >" + value.Text + "</option>");
                    });

                    if (loadDefaultValueAfterLoadingItems) {
                        loadDefaultValueAfterLoadingItems = false;
                        $("#DialogDropDownItems").trigger("change");
                    }
                },
            });
        }
        else {
            $(this).val($(this).attr("data-lastvalue"));
        }
    });

    
    $("#listboxUsers").select2({
        minimumInputLength: 0,
        multiple: true,
        width: '100%',
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $("#listboxUsers").trigger('change');
});

var loadDefaultValueAfterLoadingItems = false;
var openDialogDoNotRemoveDefaultValue = false;

function openDialog() {
    $("#DialogDropDownItems").empty();
    $('#listboxItems option').each(function (index) {
        $("#DialogDropDownItems").append($("<option/>", { value: $(this).val(), text: $(this).text(), "data-index": index, "data-defaultvalue": $(this).attr("data-defaultvalue") }));
    });
    $("#CustomFormMapDropDownsSelect").val("");

    if ($("#ReadOnly").val().toLowerCase() == "false") {
        $("#DialogSetDefaultReadOnly").prop("checked", false);
    }
    else {
        $("#DialogSetDefaultReadOnly").prop("checked", true);
    }

    var parent = $("#listboxItems").attr("data-defaultvalueindexparent");
    if (parent != undefined && parent != "") {
        openDialogDoNotRemoveDefaultValue = true;
        loadDefaultValueAfterLoadingItems = true;
        $("#CustomFormMapDropDownsSelect").val(parent);
        $("#CustomFormMapDropDownsSelect").trigger("change");
    }
    $("#dialog-set-default-items").dialog("open");
}

function SetSeparatorName(e) {
    var val = $(e).val();
    $("#NameSeparator").hide();
    if (val == " ") {
        $("#NameSeparator").text("mezera");
        $("#NameSeparator").show();
    }
    else if (val == "\t") {
        $("#NameSeparator").text("tabulátor");
        $("#NameSeparator").show();
    }
}

function showPreview(session_id) {
    $("#dialog-preview").empty();
    $("#dialog-preview").dialog("open");
    $("#dialog-preview").append("<div class='loading-32'></div>");
    $("#dialog-preview").load(RQ_URL + "/ManageShowForService/PartialViewForCustomForm?session_id=" + session_id, function () {
        $("#dialog-preview").dialog("close"); //recenter
        $("#dialog-preview").dialog("open");
    });
}

function setDepends(element) {
    var val = $(element).val();
    var item = $("#listboxItems :selected");
    $.each(item, function (index, value) {
        $(value).attr("data-depends", val);
    });
}

function ReloadTableOfFields() {
    $("#tableOfFields").load(RQ_URL + "/CustomForms/PartialTableOfFields?session_id=" + $('#hiddenSessionId').val());
}

function InitTinyMCE() {

    tinymce.init({
        selector: '#tbLayoutTemplate',
        cache_suffix: "?ver=" + ver,
        theme: "silver",
        width: "100%",
        height: "550px",
        plugins: ["emoticons preview paste code table textcolor"],
        content_css: RQ_URL + '/Content/tiny_mce.css',
        toolbar: "pastetext | bold italic strikethrough | fontsizeselect | forecolor | bullist numlist | link unlink | removeformat | undo redo | charmap code preview | tablecontrols",
        entity_encoding: "raw",
        convert_fonts_to_spans: true,
        paste_data_images: true,
        language: language,
        branding: false,
        contextmenu: false,
    });

}

//to be able to edit tinymce source code in jquery dialog
//http://stackoverflow.com/questions/18111582/tinymce-4-links-plugin-modal-in-not-editable
$(document).on('focusin', function (e) {
    if ($(e.target).closest(".mce-window").length) {
        e.stopImmediatePropagation();
    }
});

function WriteIntoTiny(what) {
    var tiny = window.tinyMCE.get('tbLayoutTemplate');
    tiny.focus();
    tiny.selection.setContent(what);
}

function dialogImport() {
    $.ajax({
        url: RQ_URL + "/CustomForms/RemoveSession",
        type: "GET",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            initPlupload(g);
            $("#DialogImportItemsHaveHeader").prop('checked', true);
            $("#DialogComma").prop("checked", true);
            $("#DialogSelectedColumn").empty();
            $("#DialogMySeparator").val("");
            $("#filelist").empty();
            $("#upload-status").hide();
            $("#ValidFile").hide();
            $("#DialogImportInvalidFile").hide();
            $("#dialogImportItems").dialog("open");
        },
    });
}


var uploader;
var filesUploaded = false;
var identifierForUpload = "";

function initPlupload(identifier) {
    filesUploaded = false;
    identifierForUpload = identifier;
    uploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/CustomForms/UploadImportFileAjax',
        browse_button: 'pickfiles',
        container: 'containerAttachments',
        max_file_size: '100mb',
        chunk_size: '1mb',
        multi_selection: false,
        unique_names: false,
        multiple_queues: false,
        multipart_params: { identifierForAsyncAttachments: identifier },
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        filters: [
       { title: "Excel Files", extensions: "csv" }
        ],
    });

    uploader.bind('Init', function (up, params) {
        $('#filelist').html("<ul id=\"filelistul\"></ul>");
    });

    uploader.init();

    uploader.bind('FilesAdded', function (up, files) {
        filesUploaded = false;
        total_upload_files = 1;
        $('#filelist').empty();
    });

    uploader.bind('UploadProgress', function (up, file) {
        $('#up-progress').attr("style", "width: " + file.percent + "%;");
        $('#lbUploadFileSize').html(file.name + " - " + formatSize(file.loaded));
        $('#lbUploadPercentage').html(file.percent);
    });

    uploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist').append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 100 MiB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#filelist').append("<div class='valid-error'>Je podporován jenom csv formát.</div>");

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploader.bind('QueueChanged', function (up, files) {
        total_upload_files = 1;
        $("#upload-status").show();
        uploader.start();

    });

    uploader.bind('FileUploaded', function (up, file) {
        $('#liFile' + file.id + " b").html("100%");
        total_upload_files--;
        if (total_upload_files == 0) {
            filesUploaded = true;
            loadHeaders(identifier);
        }
    });
}

function changeSeparator() {
    loadHeaders(identifierForUpload);
}

function loadHeaders(identifier) {
    if (filesUploaded) {
        OnAjaxBegin('Načítám data...');
        $("#DialogImportInvalidFile").hide();
        $.ajax({
            url: RQ_URL + "/CustomForms/GetImportCsvHeadrs",
            type: "POST",
            dataType: "json",
            data: JSON.stringify({
                identifierForAsyncAttachments: identifier,
                mySeparator: $("#DialogMySeparator").val(),
                haveHeader: $("#DialogImportItemsHaveHeader").is(':checked')
            }),
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                if (g.Success) {
                    $("#DialogMySeparator").val(g.separator).trigger("keyup");
                    $("#DialogSelectedColumn").empty();
                    $.each(g.headers, function (index, value) {
                        $("#DialogSelectedColumn").append("<option value='" + value.Value + "'>" + value.Text + "</option>");
                    });

                    $("#tbItemText").val("");
                    $("#aItemUpdate").attr("disabled", "disabled");
                    $("#aItemMoveUp").attr("disabled", "disabled");
                    $("#aItemMoveDown").attr("disabled", "disabled");
                    $("#aItemDelete").attr("disabled", "disabled");
                    $("#aItemDisabled").attr("disabled", "disabled");
                    $("#aItemEnable").attr("disabled", "disabled");
                    OnAjaxComplete();
                }
                else {
                    $("#DialogImportInvalidFile").show();
                    OnAjaxComplete();
                }
            },
            error: function (error) { alert(error.responseText); }
        });
    }
}

function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}