﻿
function initSearchForTickets() {
    selectedTab = "Tickets";
    $('#divSearchForTickets').html('<div class="loading-32"></div>');

    $.post(
    RQ_URL + '/Tickets/SearchForTickets',
    {
        searchText: $("#searchinputhidden").val(),
        pageIndex: $("#hiddenPageIndex").val(),
        pageSize: 10,
    },
    function (html) {
        $('#divSearchForTickets').html(html);
    },
    "html"
    )
    .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
    .done(function () {
        var splitedText = $.map($('#searchinputhidden').val().trim().split(' '), function (n, i) { return n.replace(/^\"/, "").replace(/\"$/, ""); }).filter(function (obj) { return obj.length >= 1; });

        $.each(splitedText, function (index, text) {
            $(".search-tickets-ticket .check-highlight").highlight(text, true);
        });
        refreshCounts();
    });
}

function initSearchForCustomers() {
    selectedTab = "Customers";
    $('#divSearchForCustomers').html('<div class="loading-32"></div>');

    $.post(
        RQ_URL + '/Customers/SearchForCustomers',
        {
            searchText: $("#searchinputhidden").val(),
            pageIndex: $("#hiddenCustomerPageIndex").val(),
            pageSize: 10,
        },
        function (html) {
            $('#divSearchForCustomers').html(html);
        },
        "html"
    )
        .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
        .done(function () {
            refreshCounts();
        });
}

function customersChangePage(pageIndex) {
    $('#hiddenCustomerPageIndex').val(pageIndex);
    initSearchForCustomers();
}

function ticketsChangePage(pageIndex) {
    if (selectedTab == "Tickets")
    {
        $('#hiddenPageIndex').val(pageIndex);
        initSearchForTickets();
    }
    else if (selectedTab == "DpdPackages")
    {
        $('#hiddenDpdPackasPageIndex').val(pageIndex);
        initDpdPackages();
    }
}

function initJqGridKnowledgeBase() {
    selectedTab = "KnowledgeBase";
    $("#jqGridKnowledgeBasePager").hide();
    if (!knowledgeBaseGridWasInit) {
        knowledgeBaseGridWasInit = true;
        $("#jqGridKnowledgeBase").jqGrid({
            url: RQ_URL + '/Desktop/KnowledgeBaseSearchData',
            mtype: "GET",
            styleUI: 'Bootstrap',
            datatype: "json",
            autoencode: true,
            colModel: [
                { label: Localization_SearchFor_Name, name: 'Title', width: 340, formatter: articleFormatter },
                { label: Localization_SearchFor_CreateDate, name: 'CreatedDate', width: 170 },
            ],
            shrinkToFit: true,
            sortname: 'CreatedDate',
            sortorder: 'desc',
            autowidth: true,
            height: 'auto',
            rowNum: 20,
            scrollOffset: 0,
            rowList: [20, 30, 50],
            loadComplete: function (data) {
                if (!firstCompleteLoadTicketGrid || reloadCounts) {
                    reloadCounts = false;
                    firstCompleteLoadTicketGrid = true;
                    refreshCounts();
                }
                var ts = this;
                if (ts.p.reccount === 0) {
                    $(this).hide();
                    emptyMsgKnowlegeBaseDiv.show();
                } else {
                    $(this).show();
                    emptyMsgKnowlegeBaseDiv.hide();
                }
                if (ts.p.records < 20) {
                    $("#jqGridKnowledgeBasePager").hide();
                }
                else {
                    $("#jqGridKnowledgeBasePager").show();
                }
            },
            pager: "#jqGridKnowledgeBasePager",
            postData: {
                searchText: function () {
                    return $("#searchinputhidden").val();
                },
            },
        });
        emptyMsgKnowlegeBaseDiv.insertAfter($("#jqGridKnowledgeBase").parent());

        $('#jqGridKnowledgeBase').jqGrid('navGrid', "#jqGridKnowledgeBasePager", {
            add: false,
            edit: false,
            del: false,
            refresh: true
        });
        $("#jqGridKnowledgeBase").setGridWidth($(".tabbable")[0].offsetWidth);
    }
    else {
        $('#jqGridKnowledgeBase').jqGrid('clearGridData');
        $('#jqGridKnowledgeBase').trigger("reloadGrid", [{ page: 1 }]);
    }
}

function initJqGridDocuments() {
    $("#jqGridDocumentsPager").hide();
    selectedTab = "Documents";
    if (!documentsGridWasInit) {
        documentsGridWasInit = true;
        $("#jqGridDocuments").jqGrid({
            url: RQ_URL + '/Desktop/DocumentsSearchData',
            mtype: "GET",
            styleUI: 'Bootstrap',
            datatype: "json",
            autoencode: true,
            colModel: [
                { label: Localization_SearchFor_Name, name: 'FileName', width: 340, formatter: fileNameFormat },
                { label: Localization_SearchFor_AddDate, name: 'AddDate', width: 170 },
            ],
            shrinkToFit: true,
            sortname: 'AddDate',
            sortorder: 'desc',
            autowidth: true,
            height: 'auto',
            rowNum: 20,
            scrollOffset: 0,
            rowList: [20, 30, 50],
            loadComplete: function (data) {
                if (!firstCompleteLoadTicketGrid || reloadCounts) {
                    reloadCounts = false;
                    firstCompleteLoadTicketGrid = true;
                    refreshCounts();
                }
                var ts = this;
                if (ts.p.reccount === 0) {
                    $(this).hide();
                    emptyMsgDocumentsDiv.show();
                } else {
                    $(this).show();
                    emptyMsgDocumentsDiv.hide();
                }
                if (ts.p.records < 20) {
                    $("#jqGridDocumentsPager").hide();
                }
                else {
                    $("#jqGridDocumentsPager").show();
                }
            },
            pager: "#jqGridDocumentsPager",
            postData: {
                searchText: function () {
                    return $("#searchinputhidden").val();
                },
            },
        });
        emptyMsgDocumentsDiv.insertAfter($("#jqGridDocuments").parent());

        $('#jqGridDocuments').jqGrid('navGrid', "#jqGridDocumentsPager", {
            add: false,
            edit: false,
            del: false,
            refresh: true
        });
        $("#jqGridDocuments").setGridWidth($(".tabbable")[0].offsetWidth);
    }
    else {
        $('#jqGridDocuments').jqGrid('clearGridData');
        $('#jqGridDocuments').trigger("reloadGrid", [{ page: 1 }]);
    }
}

function initJqTicketStickyNotes() {
    $("#jqGridTicketStickyNotesPager").hide();
    selectedTab = "TicketStickyNote";
    if (!ticketStickyNotesGridWasInit) {
        ticketStickyNotesGridWasInit = true;
        $("#jqGridTicketStickyNotes").jqGrid({
            url: RQ_URL + '/Desktop/TicketStickyNotesSearchData',
            mtype: "GET",
            styleUI: 'Bootstrap',
            datatype: "json",
            autoencode: true,
            colModel: [
                { label: Localization_SearchFor_Text, name: 'Text', width: 350 },
                { label: Localization_SearchFor_Author, name: 'FullName', width: 180, sortable: false, fixed: true },
                { label: Localization_SearchFor_Ticket, name: 'TicketREF', width: 130, sortable: false, fixed: true, formatter: ticketIdRefWithMessageFormat },
                { label: '<div class="right">' + Localization_SearchFor_Relevancy + '</div>', name: 'Score', width: 40, classes: "right" },
            ],
            shrinkToFit: true,
            sortname: 'Score',
            sortorder: 'desc',
            autowidth: true,
            height: 'auto',
            rowNum: 20,
            scrollOffset: 0,
            rowList: [20, 30, 50],
            loadComplete: function (data) {
                if (!firstCompleteLoadTicketGrid || reloadCounts) {
                    reloadCounts = false;
                    firstCompleteLoadTicketGrid = true;
                    refreshCounts();
                }
                var ts = this;
                if (ts.p.reccount === 0) {
                    $(this).hide();
                    emptyMsgTicketStickyNotesDiv.show();
                } else {
                    $(this).show();
                    emptyMsgTicketStickyNotesDiv.hide();
                }
                if (ts.p.records < 20) {
                    $("#jqGridTicketStickyNotesPager").hide();
                }
                else {
                    $("#jqGridTicketStickyNotesPager").show();
                }
            },
            pager: "#jqGridTicketStickyNotesPager",
            postData: {
                searchText: function () {
                    return $("#searchinputhidden").val();
                },
            },
        });
        emptyMsgDocumentsDiv.insertAfter($("#jqGridTicketStickyNotes").parent());

        $('#jqGridTicketStickyNotes').jqGrid('navGrid', "#jqGridTicketStickyNotesPager", {
            add: false,
            edit: false,
            del: false,
            refresh: true
        });
        $("#jqGridTicketStickyNotes").setGridWidth($(".tabbable")[0].offsetWidth);
    }
    else {
        $('#jqGridTicketStickyNotes').jqGrid('clearGridData');
        $('#jqGridTicketStickyNotes').trigger("reloadGrid", [{ page: 1 }]);
    }
}

function initJqUsers() {
    selectedTab = "Users";
    $('#divSearchForUsers').html('<div class="loading-32"></div>');

    $.post(
        RQ_URL + '/Desktop/SearchForUsers',
        {
            searchText: $("#searchinputhidden").val(),
            pageIndex: $("#hiddenUserPageIndex").val(),
            pageSize: 10,
        },
        function (html) {
            $('#divSearchForUsers').html(html);
        },
        "html"
    )
        .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
        .done(function () {
            refreshCounts();
        });
}

function initDpdPackages() {
    selectedTab = "DpdPackages";
    $('#divSearchForDpdPackages').html('<div class="loading-32"></div>');

    $.post(
        RQ_URL + '/Tickets/SearchForDpdPackages',
        {
            searchText: $("#searchinputhidden").val(),
            pageIndex: $("#hiddenDpdPackagesPageIndex").val(),
            pageSize: 10,
        },
        function (html) {
            $('#divSearchForDpdPackages').html(html);
        },
        "html"
    )
        .fail(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } })
        .done(function () {
            refreshCounts();
        });
}

function usersChangePage(pageIndex) {
    $('#hiddenUserPageIndex').val(pageIndex);
    initJqUsers();
}

function articleFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<a href='" + RQ_URL + "/KnowledgeBase/Article/" + rowObject.Id + "' >" + cellValue + "</a>";
    return nameLinkHtml;
}

function editFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<a href='"+ RQ_URL +"/Customers/Edit/" + rowObject.Id + "' >" + cellValue + "</a>";
    return nameLinkHtml;
}

function ticketIdRefFormat(cellValue, options, rowObject) {
    var subjectHtml = "<a href='" + RQ_URL + "/Tickets/Show/" + rowObject.TicketREF + "'>" + cellValue + "</a>";
    return subjectHtml;
}

function ticketIdRefWithMessageFormat(cellValue, options, rowObject) {
    var subjectHtml = "<a href='" + RQ_URL + "/Tickets/Show/" + rowObject.TicketREF + "#" + rowObject.Id + "'>" + cellValue + "</a>";
    return subjectHtml;
}

function emailsFormat(cellValue, options, rowObject) {
    if (cellValue == null) {
        return "<div></div>";
    }
    else {
        var arr = cellValue.split(';');

        var aHtml = "";
        for (var i = 0; i < arr.length; i++) {
            aHtml += "<a href='mailto:" + arr[i] + "'>" + arr[i] + "</a> ";
        }
        return "<div>" + aHtml + "</div>";
    }
}

function fileNameFormat(cellValue, options, rowObject) {
    return '<a href="' + RQ_URL + '/Document/GetAttachment/' + rowObject.Id + '"> ' + rowObject.FileName + '</a>';
}

function phonesFormat(cellValue, options, rowObject) {

    return cellValue == null ? "<div></div>" : "<div>" + cellValue.replace(";", ", ") + "</div>";
}

function webFormat(cellValue, options, rowObject) {
    return (cellValue == "" || cellValue == null ? "" : "<a href='" + cellValue + "'>" + cellValue + "</a>");
}

function refreshSearchTablesAndCounts() {
    reloadCounts = true;

    if (selectedTab == "Tickets") {
        $('#hiddenPageIndex').val('0');
        initSearchForTickets();
    }
    if (documentsGridWasInit && selectedTab == "Documents") {
        initJqGridDocuments();
    }
    if (knowledgeBaseGridWasInit && selectedTab == "KnowledgeBase") {
        initJqGridKnowledgeBase();
    }
    if (selectedTab == "Customers") {
        $('#hiddenCustomerPageIndex').val('0');
        initSearchForCustomers();
    }
    if (ticketStickyNotesGridWasInit && selectedTab == "TicketStickyNote") {
        initJqTicketStickyNotes();
    }
    if (selectedTab == "Users") {
        initJqUsers();
    }
    if (selectedTab == "DpdPakcages") {
        initJqDpdPackages();
    }
}

function refreshCounts() {
    $.ajax({
        url: RQ_URL + '/Desktop/GetSearchDataCounts',
        type: "POST",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        data: JSON.stringify({
            searchText: $("#searchinputhidden").val(),
        }),
        success: function (g) {
            $("#customersCount").text(g.customersCount).show();
            $("#knowledgeBaseCount").text(g.knowledgeBaseCount).show();
            $("#documentsCount").text(g.documentsCount).show();
            $("#ticketStickyNotesCount").text(g.ticketStickyNotesCount).show();
            $("#usersCount").text(g.usersCount).show();
        },
    })
    .fail(function (error) {
        if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
    });
}

function search() {
    $("#emptySearchValid").hide();
    $("#onlyOneCharValid").hide();
    if ($("#searchinput").val().length == 0) {
        $("#emptySearchValid").show();
    }
    else {
        $("#searchinputhidden").val($("#searchinput").val());
        refreshSearchTablesAndCounts();
    }
}